% lab09_ex_impulse_response.m - mathematically derived FIR filter impulse responses 

% Filter parameters
fs = 1000;       % sampling frequency
f0 = 100;        % cut-off frequency for low-pass and high-pass filters
f1 = 200;        % low frequency for band-pass and band-stop filters
f2 = 300;        % high frequency for band-pass and band-stop filters
M = 100;         % half of the filter weights
N = 2*M + 1;     % number of weights {h(n)} (b(n) in IIR filters) - always odd
n = -M :1: M;    % non-causal weights indexes

% Impulse responses - weights
hALL = zeros(1,N); hALL(M+1)=1;                         % AllPass
hLP = sin(2*pi*f0/fs*n)./(pi*n); hLP(M+1) = 2*f0/fs;    % LowPass f0
hHP = hALL - hLP;                                       % HighPass
hLP1 = sin(2*pi*f1/fs*n)./(pi*n); hLP1(M+1) = 2*f1/fs;  % LowPass f1
hLP2 = sin(2*pi*f2/fs*n)./(pi*n); hLP2(M+1) = 2*f2/fs;  % LowPass f2
hBP = hLP2 - hLP1;                                      % BandPass [f1,f2]
hBS = hALL - hBP;                                       % BandStop [f1,f2]
hH = (1-cos(pi*n))./(pi*n); hH(M+1)=0;  % Hilbert filter -90deg phase shifter
hD = cos(pi*n)./n; hD(M+1)=0;           % differentiation filter
h = hLP;        % choose filter: hLP, hHP, hBP, hBS, hH, hD
figure; stem( n, h ); title('h(n)'); xlabel('n'); grid; pause
