% lab09_ex_kaiser.m - FIR filter design using window method with Kaiser window
clear all; close all;

% Choose filter parameters
fs = 2000;        % sampling frequency (Hz)
fa1 = 150;        % low frequency  1   (Hz),  LP, BP, BS
fa2 = 200;        % low frequency  2   (Hz),  LP, BP, BS
fb1 = 300;        % high frequency 1   (Hz),  HP, BP, BS
fb2 = 350;		  % high frequency 2   (Hz),  HP, BP, BS
if(1)
  dpass = 0.001;  % allowed oscillations in passband, e.g. 0.1, 0.01, 0.001
  dstop = 0.0001; % allowed oscillations in stopband, 0.001, 0.001, 0.0001
else % Alternative: from Apass and Astop in (dB) to dpass and dstop (linear)
  Apass = 3;  Astop = 80;
  dpass = ((10^(Ap/20))-1)/((10^(Ap/20))+1);
  dstop = 10^(-As/20);
end  

type = 'lp';      % lp=LowPass, hp=HighPass, bp=BandPass, bs=BandStop

% Calculate Kaiser window parameters
if (type=='lp')	% Filter LP
    df=fa2-fa1; fc=((fa1+fa2)/2)/fs; wc=2*pi*fc;
end
if (type=='hp')	% Filter HP
    df=fb2-fb1; fc=((fb1+fb2)/2)/fs; wc=2*pi*fc;
end
if (type=='bp' | type=='bs') % Filter BP or BS
    df1=fa2-fa1; df2=fb2-fb1; df=min(df1,df2);
    f1=(fa1+(df/2))/fs; f2=(fb2-(df/2))/fs;
    w1=2*pi*f1; w2=2*pi*f2;
end
% beta = ?
d=min(dpass,dstop); A=-20*log10(d);
if(A>=50)           beta=0.1102*(A-8.7); end
if(A>21 & A<50)     beta=(0.5842*(A-21)^0.4)+0.07886*(A-21); end
if(A<=21)           beta=0; end
beta, pause
% D = ?
if(A>21)  D=(A-7.95)/14.36; end
if(A<=21) D=0.922; end
% N = ?
N=(D*fs/df)+1; N=ceil(N); if(rem(N,2)==0) N=N+1; end 
N, pause
M = (N-1)/2; m = 1 : M; n = 1 : N;

% Generate Kaiser window
% e.g. w=hanning(N)'; w=hamming(N)', w=blackman(N)'; w=chebwin(N,Astop)'
% w=Kaiser(N,beta)'; 
w = besseli( 0, beta * sqrt(1-((n-1)-M).^2/M^2) ) / besseli(0,beta);
plot(n,w,'bo-'); title('Window function w(n)'); xlabel('n'); grid; pause
