% lab09_ex_symmetry.m - symmetry types of FIR digital filters
clear all; close all;

% Impulse response - filter weights
L = 10;                           % "half" of the filter length
h0 = (0:L-1); % h0 = randn(1,L);  % "half" of the filter weights (two options) 
h1 = [  h0(1:L) 1  h0(L:-1:1) ];  % symmetry,  odd  length
h2 = [  h0(1:L)    h0(L:-1:1) ];  % symmetry,  even length, z=-1
h3 = [ -h0(1:L) 0  h0(L:-1:1) ];  % asymmetry, odd  length, z=+/-1
h4 = [ -h0(1:L)    h0(L:-1:1) ];  % asymmetry, even length, z=+1
h5 = fir1( 200, 0.5 );            % symmetry,  odd  length, Matlab example
h = h5;                           % our choice
figure; stem(h); title('h(n)'); grid; pause

% Roots (zeros) of the filter transfer function H(z)
z = roots(h); z = z( find( abs(z) < 10 ) );
alpha = 0 : pi/1000 : 2*pi; co=cos(alpha); si=sin(alpha);
figure; plot(co,si,'k-',real(z),imag(z),'bo'); title('TF Roots');
grid; pause

% Filter frequency response H(f)
fs = 2000; f = -0.25*fs : fs/10000 : 1.25*fs;
zz = exp(-j*2*pi*f/fs);     % z^(-1)
H = polyval( h(end:-1:1), zz ); Hm = freqz(h,1,f,fs); error = max(H-Hm),
figure; plot(f,20*log10(abs(H))); xlabel('f (Hz)');  title('|H(f)|');    grid; pause
figure; plot(f,unwrap(angle(H))); xlabel('f (Hz)'); title('phase H(f)'); grid; pause